package com.shuangyulin.dao;

import java.util.ArrayList;
import java.util.List;
import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import com.mysql.jdbc.Statement;
import com.shuangyulin.utils.HibernateUtil;

import com.shuangyulin.domain.ReaderType;

public class ReaderTypeDAO {

    /*ÿҳʾ¼Ŀ*/
    private final int PAGE_SIZE = 10;

    /*ѯܵҳ*/
    private int totalPage;
    public void setTotalPage(int totalPage) {
        this.totalPage = totalPage;
    }
    public int getTotalPage() {
        return totalPage;
    }

    /*ѯܼ¼*/
    private int recordNumber;
    public void setRecordNumber(int recordNumber) {
        this.recordNumber = recordNumber;
    }
    public int getRecordNumber() {
        return recordNumber;
    }

    /*ͼϢ*/
    public void AddReaderType(ReaderType readerType) throws Exception {
        Session s = null;
        Transaction tx = null;
        try { 
            s = HibernateUtil.getSession();
            tx = s.beginTransaction(); 
            s.save(readerType);
            tx.commit();
        } catch (HibernateException e) {
            if(tx != null)
                tx.rollback();
            throw e;
        } finally {
            HibernateUtil.closeSession();
        }
    }

    /*ѯReaderTypeϢ*/
    public ArrayList<ReaderType> QueryReaderTypeInfo(int currentPage) { 
        Session s = null; 
        try {
            s = HibernateUtil.getSession();
            String hql = "From ReaderType readerType where 1=1";
            Query q = s.createQuery(hql);
            /*㵱ǰʾҳĿʼ¼*/
            int startIndex = (currentPage-1) * this.PAGE_SIZE;
            q.setFirstResult(startIndex);
            q.setMaxResults(this.PAGE_SIZE);
            List readerTypeList = q.list();
            return (ArrayList<ReaderType>) readerTypeList;
        } finally {
            HibernateUtil.closeSession();
        }
    }

    /*ܣѯеReaderType¼*/
    public ArrayList<ReaderType> QueryAllReaderTypeInfo() {
        Session s = null; 
        try {
            s = HibernateUtil.getSession();
            String hql = "From ReaderType";
            Query q = s.createQuery(hql);
            List readerTypeList = q.list();
            return (ArrayList<ReaderType>) readerTypeList;
        } finally {
            HibernateUtil.closeSession();
        }
    }

    /*ܵҳͼ¼*/
    public void CalculateTotalPageAndRecordNumber() {
        Session s = null;
        try {
            s = HibernateUtil.getSession();
            String hql = "From ReaderType readerType where 1=1";
            Query q = s.createQuery(hql);
            List readerTypeList = q.list();
            recordNumber = readerTypeList.size();
            int mod = recordNumber % this.PAGE_SIZE;
            totalPage = recordNumber / this.PAGE_SIZE;
            if(mod != 0) totalPage++;
        } finally {
            HibernateUtil.closeSession();
        }
    }

    /*ȡ*/
    public ReaderType GetReaderTypeByReaderTypeId(int readerTypeId) {
        Session s = null;
        try {
            s = HibernateUtil.getSession();
            ReaderType readerType = (ReaderType)s.get(ReaderType.class, readerTypeId);
            return readerType;
        } finally {
            HibernateUtil.closeSession();
        }
    }

    /*ReaderTypeϢ*/
    public void UpdateReaderType(ReaderType readerType) throws Exception {
        Session s = null;
        Transaction tx = null;
        try {
            s = HibernateUtil.getSession();
            tx = s.beginTransaction();
            s.update(readerType);
            tx.commit();
        } catch (HibernateException e) {
            if(tx != null)
            	  tx.rollback();
            throw e;
        } finally {
            HibernateUtil.closeSession();
        }
    }

    /*ɾReaderTypeϢ*/
    public void DeleteReaderType (int readerTypeId) throws Exception {
        Session s = null;
        Transaction tx = null;
        try {
            s = HibernateUtil.getSession();
            tx = s.beginTransaction();
            Object readerType = s.get(ReaderType.class, readerTypeId);
            s.delete(readerType);
            tx.commit();
        } catch (HibernateException e) {
            if(tx != null)
            	  tx.rollback();
            throw e;
        } finally {
            HibernateUtil.closeSession();
        }
    }

}
